/* Problem URL: https://codeforces.com/gym/105900/problem/G */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vi fds(n);
    repv(i, fds) {
        cin >> i;
        i--;
    }

    vvi dp(n, vi(2, -1));

    int ans = 0;

    V<bool> frame(n);
    V<bool> vis(n);
    vi dis(n, 0);
    V<bool> loop(n);
    function<pair<int, int>(int)> dfs = [&](int i) {
        vis[i] = true;
        if (frame[fds[i]]) {
            int size = dis[i] - dis[fds[i]];
            dp[i][0] = size / 2;
            dp[i][1] = size / 2;
            loop[i] = true;
            return make_pair(fds[i], size);
        }

        frame[i] = true;
        dis[fds[i]] = dis[i] + 1;
        auto [cat, size] = dfs(fds[i]);

        frame[i] = false;
        if (cat != -1) {
            loop[i] = true;
            dp[i][0] = ans / 2;
            dp[i][1] = ans / 2;
            if (cat == i) {
                return make_pair(-1, -1);
            }
            return make_pair(cat, size);
        }

        return make_pair(-1, -1);
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }
        dfs(i);
    }

    function<void(int)> calc = [&](int i) {
        if (dp[i][0] != -1) {
            return;
        }

        dp[i][0] = dp[fds[i]][1];
        dp[i][1] = dp[fds[i]][0] + 1;


    };

    rep(i, n) {

    }

    cout << dp;

    cout << ans << '\n';
}
